% Solving the coupled 6DOF equation of motion
% Complex solving the 6DOF ODE problem
% Written by Vetle Kallk, 2020

function [eta] = calcRAO(waveW, mass, A, B, C, F)
eta = zeros(6,length(waveW));
    for i = 1:length(waveW) % For all wave frequencies
    H = zeros(6,6);
    EX = zeros(6,1); % Excitation forces
    w = waveW(i); % Wave angular frequency
    
        for r = 1:6 % 6DOF, rows 
        EX(r,1) = F(r,i); % Complex excitaiton force
            for c = 1:6 % 6DOF, columns
                    H(r,c) = -w^2*(mass(r,c)+A(r,c,i)) ...
                        + complex(0,w*B(r,c,i)) + C(r,c);
            end
        end
    % Solving matrix problem    
    eta(:,i) = H \ EX; 
    end
end
