% Calculate mass matrix
% Written by Vetle Kallaak

function [M] = massMat(mass, COG, r, r_ij)

M = zeros(6,6);

% Diagonal terms
for i=1:3
    M(i,i) = mass;
    M(3+i,3+i) = mass * r(i)^2;
end

% Adjust for center of gravity
M(1,5) = mass * COG(3);
M(1,6) = - mass * COG(2);
M(2,4) = - mass * COG(3);
M(2,6) = mass * COG(1);
M(3,4) = mass * COG(2);
M(3,5) = -mass * COG(1);
% Product of inertia
M(4,5) = mass* r_ij(1) * abs(r_ij(1));
M(4,6) = mass* r_ij(2) * abs(r_ij(2));
M(5,6) = mass* r_ij(3) * abs(r_ij(3));

% Mirror the mass matrix about the diagonal 
for i=1:5
    M(i+1:end,i) = M(i,i+1:end);
end

end



