% Function to run GeniE and HydroD in "batch mode"
% The program windows will pop up, but close automatically when
% finished
    
function cont = runSesam(p, sesam, run)
% Run these lines to get help with command line options
%!"C:\Program Files\DNVGL\GeniE V7.13-11\Program\GenieR" /?
%!"C:\Program Files (x86)\DNVGL\HydroD V4.10-01\Program\HydroD" /?
%%
SF = sesam.workspace; % Folder name
cont = true; % continue
if run == 1
    %% Run GeniE
    if p.tilt == 0
        status=-1;
        tic
        fprintf('Running GeniE...\n');
        while status ~= 0
            % This line runs GeniE
            commandGE = ['"C:\Program Files\DNVGL\GeniE V7.13-11\Program\GenieR" C:\DNVGL\Workspaces\GeniE\' SF '\' SF ' /new /licenses=CurvedGeometry,FrameCodeCheck,PlateCodeCheck /com=C:\DNVGL\Workspaces\GeniE\GeniE_fromMatlab.js /exit'];
            status = system(commandGE);
        end
        t=toc;
        fprintf('GeniE finished. Time = %0.2f sec\n',t);

        fid = fopen('C:\DNVGL\Workspaces\GeniE\T1.FEM','r');
        A = textscan(fid,'%s','Delimiter','\n');
        data = A{1};
        status=fclose(fid);
        if status ~= 0
            fprintf('Did not close file!\n');
        end

        numEl=0;
        for ii = 1:numel(data)
            if strfind(data{ii},'GELREF')
                numEl=numEl+1;
            end
        end
        fprintf('%d elements in model\n\n',numEl);
    else
        fprintf('Run GeniE manually for tilted platform!\nSave T1.FEM in GeniE workspace. \n');
    end
    
    choice = menu('Run HydroD?','Yes','No');
    if choice == 2 || choice == 0
        cont = false;
    else

    %% Run HydroD
    status = -1;
    % Copy panel model from GeniE to HydroD workspace environment
    statuscf = copyfile('C:\DNVGL\Workspaces\GeniE\T1.FEM','C:\DNVGL\Workspaces\HydroD');
    %%
    tic
    fprintf('Running HydroD...\n');
    if statuscf
        while status ~= 0
            % This line runs HydroD
            commandHD = ['"C:\Program Files (x86)\DNVGL\HydroD V4.10-01\Program\HydroD" C:\DNVGL\Workspaces\HydroD\' SF '\' SF ' /new /licenses=Wadam /com=C:\DNVGL\Workspaces\HydroD\HydroD_fromMatlab.js /exit'];
            status = system(commandHD);
        end
    end
    t=toc;
    fprintf('HydroD finished. Time = %0.2f sec\n\n',t);
    end
elseif run == 2
    %% Run HydroD with extra damping
    status = -1;
    tic
    fprintf('Running HydroD...\n');
    while status ~= 0
        % This line runs HydroD
        commandHD = ['"C:\Program Files (x86)\DNVGL\HydroD V4.10-01\Program\HydroD" C:\DNVGL\Workspaces\HydroD\' SF '\' SF ' /licenses=Wadam /com=C:\DNVGL\Workspaces\HydroD\HydroD_addDamping.js /exit'];
        status = system(commandHD);
    end
    t=toc;
    fprintf('HydroD finished. Time = %0.2f sec\n\n',t);
else
    disp('Invalid run number in runSesam');
end
end % Function
    